import 'package:auto_size_text/auto_size_text.dart';
import 'package:easy_localization/easy_localization.dart';
import 'package:flutter/material.dart';
import 'package:flutter_svg/flutter_svg.dart';
import 'package:mohem_flutter_app/app_state/app_state.dart';
import 'package:mohem_flutter_app/classes/colors.dart';
import 'package:mohem_flutter_app/classes/decorations_helper.dart';
import 'package:mohem_flutter_app/config/routes.dart';
import 'package:mohem_flutter_app/extensions/int_extensions.dart';
import 'package:mohem_flutter_app/extensions/widget_extensions.dart';
import 'package:mohem_flutter_app/generated/locale_keys.g.dart';
import 'package:mohem_flutter_app/ui/marathon/marathon_intro_screen.dart';
import 'package:mohem_flutter_app/ui/marathon/marathon_provider.dart';
import 'package:mohem_flutter_app/ui/marathon/widgets/countdown_timer.dart';
import 'package:provider/provider.dart';
import 'dart:math' as math;

class MarathonBanner extends StatelessWidget {
  const MarathonBanner({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    MarathonProvider provider = context.read<MarathonProvider>();
    return Container(
      decoration: MyDecorations.shadowDecoration,
      height: MediaQuery.of(context).size.height * 0.11,
      clipBehavior: Clip.antiAlias,
      child: Stack(
        children: [
          Transform(
            alignment: Alignment.center,
            transform: Matrix4.rotationY(
              AppState().isArabic(context) ? math.pi : 0,
            ),
            child: SvgPicture.asset(
              "assets/images/marathon_banner_bg.svg",
              fit: BoxFit.fill,
              width: double.infinity,
            ),
          ),
          Positioned(
            left: -20,
            top: -10,
            child: Transform.rotate(
              angle: 15,
              child: Container(
                width: 65,
                height: 32,
                color: MyColors.darkDigitColor,
              ),
            ),
          ),
          SizedBox(
            width: double.infinity,
            height: double.infinity,
            child: Row(
              children: [
                const Expanded(
                  flex: 3,
                  child: SizedBox(
                    width: double.infinity,
                    height: double.infinity,
                  ),
                ),
                Expanded(
                  flex: 5,
                  child: SizedBox(
                    width: double.infinity,
                    height: double.infinity,
                    child: Row(
                      mainAxisAlignment: MainAxisAlignment.start,
                      children: <Widget>[
                        Column(
                          mainAxisAlignment: MainAxisAlignment.center,
                          crossAxisAlignment: CrossAxisAlignment.start,
                          mainAxisSize: MainAxisSize.min,
                          children: <Widget>[
                            AppState().isArabic(context) ? 0.height : 5.height,
                            AutoSizeText(
                              LocaleKeys.getReadyForContest.tr(),
                              minFontSize: 08,
                              maxFontSize: 11,
                              style: TextStyle(
                                fontStyle: FontStyle.italic,
                                fontWeight: FontWeight.w600,
                                color: MyColors.white.withOpacity(0.83),
                                letterSpacing: -0.4,
                              ),
                            ),
                            AutoSizeText(
                              "Saudi Arabia",
                              style: TextStyle(
                                fontStyle: FontStyle.italic,
                                fontSize: 19,
                                fontWeight: FontWeight.bold,
                                color: MyColors.white.withOpacity(0.83),
                                height: 32 / 22,
                              ),
                            ),
                            3.height,
                            BuildCountdownTimer(
                              timeToMarathon: dummyEndTime,
                              provider: provider,
                              screenFlag: 0,
                            ),
                          ],
                        ).paddingOnly(
                          left: AppState().isArabic(context) ? 12 : 3,
                          right: AppState().isArabic(context) ? 3 : 12,
                        )
                      ],
                    ),
                  ),
                ),
              ],
            ),
          ),
          Align(
            alignment: Alignment.topLeft,
            child: SizedBox(
              height: 20,
              width: 35,
              child: Transform.rotate(
                angle: -math.pi / 4.5,
                child: Text(
                  LocaleKeys.brainMarathon.tr(),
                  textAlign: TextAlign.center,
                  maxLines: 2,
                  style: const TextStyle(
                    color: MyColors.kWhiteColor,
                    fontWeight: FontWeight.bold,
                    fontSize: 6,
                    height: 1.2,
                  ),
                ),
              ),
            ),
          ).paddingOnly(top: 5),
          !AppState().isArabic(context)
              ? Positioned(
                  right: 0,
                  bottom: 0,
                  child: RotatedBox(
                    quarterTurns: 4,
                    child: SvgPicture.asset("assets/images/arrow_next.svg", color: MyColors.darkDigitColor),
                  ).paddingAll(15),
                )
              : Positioned(
                  bottom: 0,
                  left: 0,
                  child: RotatedBox(
                    quarterTurns: 2,
                    child: SvgPicture.asset("assets/images/arrow_next.svg", color: MyColors.darkDigitColor),
                  ).paddingAll(15),
                ),
        ],
      ).onPress(
        () => Navigator.pushNamed(context, AppRoutes.marathonIntroScreen),
      ),
    );
  }
}
